;; modify key
(define mod-alt     #x1)
(define mod-control #x2)
(define mod-shift   #x4)
(define mod-win     #x8)

;; virtual key

(define vk-lbutton        #x01)
(define vk-rbutton        #x02)
(define vk-cancel         #x03)
(define vk-mbutton        #x04)


(define vk-xbutton1       #x05)
(define vk-xbutton2       #x06)

(define vk-back           #x08)
(define vk-tab            #x09)

(define vk-clear          #x0c)
(define vk-return         #x0d)
(define vk-shift          #x10)
(define vk-control        #x11)
(define vk-menu           #x12)
(define vk-pause          #x13)
(define vk-capital        #x14)

(define vk-kana           #x15)
(define vk-hangeul        #x15)
(define vk-hangul         #x15)
(define vk-junja          #x17)
(define vk-final          #x18)
(define vk-hanja          #x19)
(define vk-kanji          #x19)

(define vk-escape         #x1b)

(define vk-convert        #x1c)
(define vk-nonconvert     #x1d)
(define vk-accept         #x1e)
(define vk-modechange     #x1f)

(define vk-space          #x20)
(define vk-prior          #x21)
(define vk-next           #x22)
(define vk-end            #x23)
(define vk-home           #x24)
(define vk-left           #x25)
(define vk-up             #x26)
(define vk-right          #x27)
(define vk-down           #x28)
(define vk-select         #x29)
(define vk-print          #x2a)
(define vk-execute        #x2b)
(define vk-snapshot       #x2c)
(define vk-insert         #x2d)
(define vk-delete         #x2e)
(define vk-help           #x2f)

(define vk-lwin           #x5b)
(define vk-rwin           #x5c)
(define vk-apps           #x5d)

(define vk-sleep          #x5f)

(define vk-numpad0        #x60)
(define vk-numpad1        #x61)
(define vk-numpad2        #x62)
(define vk-numpad3        #x63)
(define vk-numpad4        #x64)
(define vk-numpad5        #x65)
(define vk-numpad6        #x66)
(define vk-numpad7        #x67)
(define vk-numpad8        #x68)
(define vk-numpad9        #x69)
(define vk-multiply       #x6a)
(define vk-add            #x6b)
(define vk-separator      #x6c)
(define vk-subtract       #x6d)
(define vk-decimal        #x6e)
(define vk-divide         #x6f)
(define vk-f1             #x70)
(define vk-f2             #x71)
(define vk-f3             #x72)
(define vk-f4             #x73)
(define vk-f5             #x74)
(define vk-f6             #x75)
(define vk-f7             #x76)
(define vk-f8             #x77)
(define vk-f9             #x78)
(define vk-f10            #x79)
(define vk-f11            #x7a)
(define vk-f12            #x7b)
(define vk-f13            #x7c)
(define vk-f14            #x7d)
(define vk-f15            #x7e)
(define vk-f16            #x7f)
(define vk-f17            #x80)
(define vk-f18            #x81)
(define vk-f19            #x82)
(define vk-f20            #x83)
(define vk-f21            #x84)
(define vk-f22            #x85)
(define vk-f23            #x86)
(define vk-f24            #x87)


;; SetWindowPos Flags
(define swp-nosize          #x0001)
(define swp-nomove          #x0002)
(define swp-nozorder        #x0004)
(define swp-noredraw        #x0008)
(define swp-noactivate      #x0010)
(define swp-framechanged    #x0020)
(define swp-showwindow      #x0040)
(define swp-hidewindow      #x0080)
(define swp-nocopybits      #x0100)
(define swp-noownerzorder   #x0200)
(define swp-nosendchanging  #x0400)

(define swp-drawframe       swp-framechanged)
(define swp-noreposition    swp-noownerzorder)

(define swp-defererase      #x2000)
(define swp-asyncwindowpos  #x4000)

(define hwnd-top        0)
(define hwnd-bottom     1)
(define hwnd-topmost   -1)
(define hwnd-notopmost -2)

;; ShowWindow() Commands
(define sw-hide             0 )
(define sw-shownormal       1 )
(define sw-normal           1 )
(define sw-showminimized    2 )
(define sw-showmaximized    3 )
(define sw-maximize         3 )
(define sw-shownoactivate   4 )
(define sw-show             5 )
(define sw-minimize         6 )
(define sw-showminnoactive  7 )
(define sw-showna           8 )
(define sw-restore          9 )
(define sw-showdefault      10)
(define sw-forceminimize    11)
(define sw-max              11)

; GetkWindow Commands
(define gw-hwndfirst        0)
(define gw-hwndlast         1)
(define gw-hwndnext         2)
(define gw-hwndprev         3)
(define gw-owner            4)
(define gw-child            5)

;; Window Styles
(define ws-overlapped       #x00000000)
(define ws-popup            #x80000000)
(define ws-child            #x40000000)
(define ws-minimize         #x20000000)
(define ws-visible          #x10000000)
(define ws-disabled         #x08000000)
(define ws-clipsiblings     #x04000000)
(define ws-clipchildren     #x02000000)
(define ws-maximize         #x01000000)
(define ws-caption          #x00c00000)
(define ws-border           #x00800000)
(define ws-dlgframe         #x00400000)
(define ws-vscroll          #x00200000)
(define ws-hscroll          #x00100000)
(define ws-sysmenu          #x00080000)
(define ws-thickframe       #x00040000)
(define ws-group            #x00020000)
(define ws-tabstop          #x00010000)

(define ws-minimizebox      #x00020000)
(define ws-maximizebox      #x00010000)


(define ws-tiled            ws-overlapped)
(define ws-iconic           ws-minimize)
(define ws-sizebox          ws-thickframe)
;(define ws-tiledwindow      ws-overlappedwindow)

(define ws-overlappedwindow (+ ws-overlapped
			       ws-caption
			       ws-sysmenu
			       ws-thickframe
			       ws-minimizebox
			       ws-maximizebox))

(define ws-popupwindow      (+ ws-popup
			       ws-border
			       ws-sysmenu))

(define ws-childwindow      ws-child)


(define ws-ex-dlgmodalframe     #x00000001)
(define ws-ex-noparentnotify    #x00000004)
(define ws-ex-topmost           #x00000008)
(define ws-ex-acceptfiles       #x00000010)
(define ws-ex-transparent       #x00000020)
(define ws-ex-mdichild          #x00000040)
(define ws-ex-toolwindow        #x00000080)
(define ws-ex-windowedge        #x00000100)
(define ws-ex-clientedge        #x00000200)
(define ws-ex-contexthelp       #x00000400)
(define ws-ex-right             #x00001000)
(define ws-ex-left              #x00000000)
(define ws-ex-rtlreading        #x00002000)
(define ws-ex-ltrreading        #x00000000)
(define ws-ex-leftscrollbar     #x00004000)
(define ws-ex-rightscrollbar    #x00000000)
(define ws-ex-controlparent     #x00010000)
(define ws-ex-staticedge        #x00020000)
(define ws-ex-appwindow         #x00040000)
(define ws-ex-overlappedwindow  (+ ws-ex-windowedge ws-ex-clientedge))
(define ws-ex-palettewindow     (+ ws-ex-windowedge ws-ex-toolwindow ws-ex-topmost))
(define ws-ex-layered           #x00080000)
(define ws-ex-noinheritlayout   #x00100000)
(define ws-ex-layoutrtl         #x00400000)
(define ws-ex-composited        #x02000000)
(define ws-ex-noactivate        #x08000000)

(define es-left             #x0000)
(define es-center           #x0001)
(define es-right            #x0002)
(define es-multiline        #x0004)
(define es-uppercase        #x0008)
(define es-lowercase        #x0010)
(define es-password         #x0020)
(define es-autovscroll      #x0040)
(define es-autohscroll      #x0080)
(define es-nohidesel        #x0100)
(define es-oemconvert       #x0400)
(define es-readonly         #x0800)
(define es-wantreturn       #x1000)
(define es-number           #x2000)

(define bs-pushbutton       #x00000000)
(define bs-defpushbutton    #x00000001)
(define bs-checkbox         #x00000002)
(define bs-autocheckbox     #x00000003)
(define bs-radiobutton      #x00000004)
(define bs-3state           #x00000005)
(define bs-auto3state       #x00000006)
(define bs-groupbox         #x00000007)
(define bs-userbutton       #x00000008)
(define bs-autoradiobutton  #x00000009)
(define bs-pushbox          #x0000000a)
(define bs-ownerdraw        #x0000000b)
(define bs-typemask         #x0000000f)
(define bs-lefttext         #x00000020)
(define bs-text             #x00000000)
(define bs-icon             #x00000040)
(define bs-bitmap           #x00000080)
(define bs-left             #x00000100)
(define bs-right            #x00000200)
(define bs-center           #x00000300)
(define bs-top              #x00000400)
(define bs-bottom           #x00000800)
(define bs-vcenter          #x00000c00)
(define bs-pushlike         #x00001000)
(define bs-multiline        #x00002000)
(define bs-notify           #x00004000)
(define bs-flat             #x00008000)
(define bs-rightbutton      bs-lefttext)

(define lbs-notify            #x0001)
(define lbs-sort              #x0002)
(define lbs-noredraw          #x0004)
(define lbs-multiplesel       #x0008)
(define lbs-ownerdrawfixed    #x0010)
(define lbs-ownerdrawvariable #x0020)
(define lbs-hasstrings        #x0040)
(define lbs-usetabstops       #x0080)
(define lbs-nointegralheight  #x0100)
(define lbs-multicolumn       #x0200)
(define lbs-wantkeyboardinput #x0400)
(define lbs-extendedsel       #x0800)
(define lbs-disablenoscroll   #x1000)
(define lbs-nodata            #x2000)

(define cbs-simple            #x0001)
(define cbs-dropdown          #x0002)
(define cbs-dropdownlist      #x0003)
(define cbs-ownerdrawfixed    #x0010)
(define cbs-ownerdrawvariable #x0020)
(define cbs-autohscroll       #x0040)
(define cbs-oemconvert        #x0080)
(define cbs-sort              #x0100)
(define cbs-hasstrings        #x0200)
(define cbs-nointegralheight  #x0400)
(define cbs-disablenoscroll   #x0800)
(define cbs-uppercase         #x2000)
(define cbs-lowercase         #x4000)

;; Window Messages

(define wm-null                         #x0000)
(define wm-create                       #x0001)
(define wm-destroy                      #x0002)
(define wm-move                         #x0003)
(define wm-size                         #x0005)

(define wm-activate                     #x0006)
  
(define wm-setfocus                     #x0007)
(define wm-killfocus                    #x0008)
(define wm-enable                       #x000a)
(define wm-setredraw                    #x000b)
(define wm-settext                      #x000c)
(define wm-gettext                      #x000d)
(define wm-gettextlength                #x000e)
(define wm-paint                        #x000f)
(define wm-close                        #x0010)

(define wm-queryendsession              #x0011)
(define wm-queryopen                    #x0013)
(define wm-endsession                   #x0016)

(define wm-quit                         #x0012)
(define wm-erasebkgnd                   #x0014)
(define wm-syscolorchange               #x0015)
(define wm-showwindow                   #x0018)
(define wm-wininichange                 #x001a)

(define wm-settingchange                wm-wininichange)



(define wm-devmodechange                #x001b)
(define wm-activateapp                  #x001c)
(define wm-fontchange                   #x001d)
(define wm-timechange                   #x001e)
(define wm-cancelmode                   #x001f)
(define wm-setcursor                    #x0020)
(define wm-mouseactivate                #x0021)
(define wm-childactivate                #x0022)
(define wm-queuesync                    #x0023)

(define wm-getminmaxinfo                #x0024)

(define wm-painticon                    #x0026)
(define wm-iconerasebkgnd               #x0027)
(define wm-nextdlgctl                   #x0028)
(define wm-spoolerstatus                #x002a)
(define wm-drawitem                     #x002b)
(define wm-measureitem                  #x002c)
(define wm-deleteitem                   #x002d)
(define wm-vkeytoitem                   #x002e)
(define wm-chartoitem                   #x002f)
(define wm-setfont                      #x0030)
(define wm-getfont                      #x0031)
(define wm-sethotkey                    #x0032)
(define wm-gethotkey                    #x0033)
(define wm-querydragicon                #x0037)
(define wm-compareitem                  #x0039)


(define wm-getobject                    #x003d)


(define wm-compacting                   #x0041)
(define wm-commnotify                   #x0044)
(define wm-windowposchanging            #x0046)
(define wm-windowposchanged             #x0047)

(define wm-power                        #x0048)

(define wm-copydata                     #x004a)
(define wm-canceljournal                #x004b)


(define wm-notify                       #x004e)
(define wm-inputlangchangerequest       #x0050)
(define wm-inputlangchange              #x0051)
(define wm-tcard                        #x0052)
(define wm-help                         #x0053)
(define wm-userchanged                  #x0054)
(define wm-notifyformat                 #x0055)


(define wm-contextmenu                  #x007b)
(define wm-stylechanging                #x007c)
(define wm-stylechanged                 #x007d)
(define wm-displaychange                #x007e)
(define wm-geticon                      #x007f)
(define wm-seticon                      #x0080)


(define wm-nccreate                     #x0081)
(define wm-ncdestroy                    #x0082)
(define wm-nccalcsize                   #x0083)
(define wm-nchittest                    #x0084)
(define wm-ncpaint                      #x0085)
(define wm-ncactivate                   #x0086)
(define wm-getdlgcode                   #x0087)

(define wm-syncpaint                    #x0088)

(define wm-ncmousemove                  #x00a0)
(define wm-nclbuttondown                #x00a1)
(define wm-nclbuttonup                  #x00a2)
(define wm-nclbuttondblclk              #x00a3)
(define wm-ncrbuttondown                #x00a4)
(define wm-ncrbuttonup                  #x00a5)
(define wm-ncrbuttondblclk              #x00a6)
(define wm-ncmbuttondown                #x00a7)
(define wm-ncmbuttonup                  #x00a8)
(define wm-ncmbuttondblclk              #x00a9)




(define wm-ncxbuttondown                #x00ab)
(define wm-ncxbuttonup                  #x00ac)
(define wm-ncxbuttondblclk              #x00ad)




(define wm-input                        #x00ff)


(define wm-keyfirst                     #x0100)
(define wm-keydown                      #x0100)
(define wm-keyup                        #x0101)
(define wm-char                         #x0102)
(define wm-deadchar                     #x0103)
(define wm-syskeydown                   #x0104)
(define wm-syskeyup                     #x0105)
(define wm-syschar                      #x0106)
(define wm-sysdeadchar                  #x0107)

(define wm-unichar                      #x0109)
(define wm-keylast                      #x0109)
(define unicode-nochar                  #xffff)

(define wm-keylast                      #x0108)



(define wm-ime-startcomposition         #x010d)
(define wm-ime-endcomposition           #x010e)
(define wm-ime-composition              #x010f)
(define wm-ime-keylast                  #x010f)


(define wm-initdialog                   #x0110)
(define wm-command                      #x0111)
(define wm-syscommand                   #x0112)
(define wm-timer                        #x0113)
(define wm-hscroll                      #x0114)
(define wm-vscroll                      #x0115)
(define wm-initmenu                     #x0116)
(define wm-initmenupopup                #x0117)
(define wm-menuselect                   #x011f)
(define wm-menuchar                     #x0120)
(define wm-enteridle                    #x0121)


(define wm-menurbuttonup                #x0122)
(define wm-menudrag                     #x0123)
(define wm-menugetobject                #x0124)
(define wm-uninitmenupopup              #x0125)
(define wm-menucommand                  #x0126)



(define wm-changeuistate                #x0127)
(define wm-updateuistate                #x0128)
(define wm-queryuistate                 #x0129)

(define wm-ctlcolormsgbox               #x0132)
(define wm-ctlcoloredit                 #x0133)
(define wm-ctlcolorlistbox              #x0134)
(define wm-ctlcolorbtn                  #x0135)
(define wm-ctlcolordlg                  #x0136)
(define wm-ctlcolorscrollbar            #x0137)
(define wm-ctlcolorstatic               #x0138)
(define mn-gethmenu                     #x01e1)

(define wm-mousefirst                   #x0200)
(define wm-mousemove                    #x0200)
(define wm-lbuttondown                  #x0201)
(define wm-lbuttonup                    #x0202)
(define wm-lbuttondblclk                #x0203)
(define wm-rbuttondown                  #x0204)
(define wm-rbuttonup                    #x0205)
(define wm-rbuttondblclk                #x0206)
(define wm-mbuttondown                  #x0207)
(define wm-mbuttonup                    #x0208)
(define wm-mbuttondblclk                #x0209)
(define wm-mousewheel                   #x020a)
(define wm-xbuttondown                  #x020b)
(define wm-xbuttonup                    #x020c)
(define wm-xbuttondblclk                #x020d)
(define wm-mouselast                    #x020d)
(define wm-mouselast                    #x020a)
(define wm-mouselast                    #x0209)
(define wm-parentnotify                 #x0210)
(define wm-entermenuloop                #x0211)
(define wm-exitmenuloop                 #x0212)
(define wm-nextmenu                     #x0213)
(define wm-sizing                       #x0214)
(define wm-capturechanged               #x0215)
(define wm-moving                       #x0216)
(define wm-powerbroadcast               #x0218)
(define wm-devicechange                 #x0219)
(define wm-mdicreate                    #x0220)
(define wm-mdidestroy                   #x0221)
(define wm-mdiactivate                  #x0222)
(define wm-mdirestore                   #x0223)
(define wm-mdinext                      #x0224)
(define wm-mdimaximize                  #x0225)
(define wm-mditile                      #x0226)
(define wm-mdicascade                   #x0227)
(define wm-mdiiconarrange               #x0228)
(define wm-mdigetactive                 #x0229)
(define wm-mdisetmenu                   #x0230)
(define wm-entersizemove                #x0231)
(define wm-exitsizemove                 #x0232)
(define wm-dropfiles                    #x0233)
(define wm-mdirefreshmenu               #x0234)
(define wm-ime-setcontext               #x0281)
(define wm-ime-notify                   #x0282)
(define wm-ime-control                  #x0283)
(define wm-ime-compositionfull          #x0284)
(define wm-ime-select                   #x0285)
(define wm-ime-char                     #x0286)
(define wm-ime-request                  #x0288)
(define wm-ime-keydown                  #x0290)
(define wm-ime-keyup                    #x0291)
(define wm-mousehover                   #x02a1)
(define wm-mouseleave                   #x02a3)
(define wm-ncmousehover                 #x02a0)
(define wm-ncmouseleave                 #x02a2)
(define wm-wtssession-change            #x02b1)
(define wm-tablet-first                 #x02c0)
(define wm-tablet-last                  #x02df)

(define wm-cut                          #x0300)
(define wm-copy                         #x0301)
(define wm-paste                        #x0302)
(define wm-clear                        #x0303)
(define wm-undo                         #x0304)
(define wm-renderformat                 #x0305)
(define wm-renderallformats             #x0306)
(define wm-destroyclipboard             #x0307)
(define wm-drawclipboard                #x0308)
(define wm-paintclipboard               #x0309)
(define wm-vscrollclipboard             #x030a)
(define wm-sizeclipboard                #x030b)
(define wm-askcbformatname              #x030c)
(define wm-changecbchain                #x030d)
(define wm-hscrollclipboard             #x030e)
(define wm-querynewpalette              #x030f)
(define wm-paletteischanging            #x0310)
(define wm-palettechanged               #x0311)
(define wm-hotkey                       #x0312)

;;;; System Menu Command Values
(define sc-size         #xf000)
(define sc-move         #xf010)
(define sc-minimize     #xf020)
(define sc-maximize     #xf030)
(define sc-nextwindow   #xf040)
(define sc-prevwindow   #xf050)
(define sc-close        #xf060)
(define sc-vscroll      #xf070)
(define sc-hscroll      #xf080)
(define sc-mousemenu    #xf090)
(define sc-keymenu      #xf100)
(define sc-arrange      #xf110)
(define sc-restore      #xf120)
(define sc-tasklist     #xf130)
(define sc-screensave   #xf140)
(define sc-hotkey       #xf150)
(define sc-default      #xf160)
(define sc-monitorpower #xf170)
(define sc-contexthelp  #xf180)
(define sc-separator    #xf00f)
;; obsolete names
(define sc-icon         sc-minimize)
(define sc-zoom         sc-maximize)

;;;; GetSystemMetrics() codes

(define sm-cxscreen             0)
(define sm-cyscreen             1)
(define sm-cxvscroll            2)
(define sm-cyhscroll            3)
(define sm-cycaption            4)
(define sm-cxborder             5)
(define sm-cyborder             6)
(define sm-cxdlgframe           7)
(define sm-cydlgframe           8)
(define sm-cyvthumb             9)
(define sm-cxhthumb             10)
(define sm-cxicon               11)
(define sm-cyicon               12)
(define sm-cxcursor             13)
(define sm-cycursor             14)
(define sm-cymenu               15)
(define sm-cxfullscreen         16)
(define sm-cyfullscreen         17)
(define sm-cykanjiwindow        18)
(define sm-mousepresent         19)
(define sm-cyvscroll            20)
(define sm-cxhscroll            21)
(define sm-debug                22)
(define sm-swapbutton           23)
(define sm-reserved1            24)
(define sm-reserved2            25)
(define sm-reserved3            26)
(define sm-reserved4            27)
(define sm-cxmin                28)
(define sm-cymin                29)
(define sm-cxsize               30)
(define sm-cysize               31)
(define sm-cxframe              32)
(define sm-cyframe              33)
(define sm-cxmintrack           34)
(define sm-cymintrack           35)
(define sm-cxdoubleclk          36)
(define sm-cydoubleclk          37)
(define sm-cxiconspacing        38)
(define sm-cyiconspacing        39)
(define sm-menudropalignment    40)
(define sm-penwindows           41)
(define sm-dbcsenabled          42)
(define sm-cmousebuttons        43)
(define sm-cxfixedframe         sm-cxdlgframe)
(define sm-cyfixedframe         sm-cydlgframe)
(define sm-cxsizeframe          sm-cxframe)
(define sm-cysizeframe          sm-cyframe)
(define sm-secure               44)
(define sm-cxedge               45)
(define sm-cyedge               46)
(define sm-cxminspacing         47)
(define sm-cyminspacing         48)
(define sm-cxsmicon             49)
(define sm-cysmicon             50)
(define sm-cysmcaption          51)
(define sm-cxsmsize             52)
(define sm-cysmsize             53)
(define sm-cxmenusize           54)
(define sm-cymenusize           55)
(define sm-arrange              56)
(define sm-cxminimized          57)
(define sm-cyminimized          58)
(define sm-cxmaxtrack           59)
(define sm-cymaxtrack           60)
(define sm-cxmaximized          61)
(define sm-cymaximized          62)
(define sm-network              63)
(define sm-cleanboot            67)
(define sm-cxdrag               68)
(define sm-cydrag               69)
(define sm-showsounds           70)
(define sm-cxmenucheck          71   )
(define sm-cymenucheck          72)
(define sm-slowmachine          73)
(define sm-mideastenabled       74)
(define sm-mousewheelpresent    75)
(define sm-xvirtualscreen       76)
(define sm-yvirtualscreen       77)
(define sm-cxvirtualscreen      78)
(define sm-cyvirtualscreen      79)
(define sm-cmonitors            80)
(define sm-samedisplayformat    81)
(define sm-immenabled           82)
(define sm-cxfocusborder        83)
(define sm-cyfocusborder        84)
(define sm-tabletpc             86)
(define sm-mediacenter          87)
(define sm-starter              88)
(define sm-serverr2             89)
(define sm-cmetrics             76)
(define sm-cmetrics             83)
(define sm-cmetrics             90)
(define sm-remotesession        #x1000)
(define sm-shuttingdown         #x2000)
(define sm-remotecontrol        #x2001)
(define sm-caretblinkingenabled #x2002)

